'''
    Author: Kulverstukas
    Date: 2013.09.02
    Website: http://9v.lt
    Description:
        Database maker for d0xbase.
        Written as a helper script for 2013 programmer's day :)
'''

import sqlite3

#=========== CONSTANTS ============
DATA_FILE = "userdata.txt"
MONTHS = {"January":1, "February":2, "March":3, "April":4, "May":5, "June":6, "July":7, "August":8, "September":9, "October":10, "November":11, "December":12}
#==================================
def makeDate(dateStr):
    tmp = dateStr.replace("Join Date: ", "").split(' ')
    return "%s.%d.%s" % (tmp[2][:-1], MONTHS[tmp[0]], tmp[1][:-1])
#==================================
dbConn = sqlite3.connect("dox.db")
dbCurs = dbConn.cursor()
dbCurs.execute("CREATE TABLE person (id INTEGER PRIMARY KEY, information TEXT, lastModDate TEXT)")

f = open(DATA_FILE, 'r')
profileBuff = ""
id = 0
modDate = ""
profileCount = 1
for line in f:
    if (line.strip() == "********************************************************************"):
        id += 1
        dbCurs.execute("INSERT INTO person VALUES (:id, :info, :lastModDate)",{"id":id, "info":profileBuff, "lastModDate":modDate})
        profileBuff = ""
        print "Processed profile: %d" % profileCount
        profileCount += 1
    else:
        profileBuff += line.strip()+'\n'
        if ("Join Date" in line):
            modDate = makeDate(line)
dbConn.commit()
dbCurs.close()

